<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="../style.css">
</head>
<body>
    <div class="content">
    <h1>Все про SQL</h1>
    <span>
        sql - язык программирования, применяемый для создания модификации и управления данными в базе данных. 
    <br>
        С помощью этого языка мы можем писать запросы (у него свой синтаксис и свои команды)
    </span>
    <br>
    <span>
        MySql - это свободная реляционная система управления базами данных 
    </span>
    <br>
    <span>
        Система управления базами данных - совокупность программных средств, обеспечивающих управление созданием и использованием баз данных. 
    </span>
    <br>
    <span>
        phpMyAdmin - это веб приложение с открытым кодом, написанное на языке PHP и представляет собой веб-интерфейс для администрирования СУБД MySQL. 
    <br>
        phpMyAdmin написан специально для того чтоб управлять MySQL. очень популярный  веб разработке. 
    </span>
    <br>
    <h2>Установка сервера и запуск phpMyAdmin</h2>

        <ul>
            <li>Установка локального сервера OpenServer(любую версию). Скачать с официального сайта и установить.</li>
            <li>Запускаем опен сервер(красный фложок -- запустить)</li>
            <li>там же заходим в phpMyAdmin и регестрируемся. Левее все базы данных сверху меню(потом посмотрим) справа инфа о сервере и документация, так же есть настройка внешнего вида(вкусовщина)</li>
            
        </ul>
        <h3>Структура</h3>
        <span> Список БД находиться с права(уже говорил), стоит основной контейнер в котором хранятся таблицы(нажми на плюс и там они все). Таблице хранят в себе все данные. в таблице есть столбцы, которые называются полями или картеж, а содержимое называется записью. 
        в разделе обзор можем смотреть все записи в таблице. 
        </span>
    <h2>
        Типы полей
    </h2>    
    <span>
        тип поля это в роде переменной в пхп(контейнер который хранит данных). Поля могут быть только определенного типа, 4 основных из них:
    </span>
    <ul>
        <li><b> VARCHAR</b> - идефльный тип данных для всяких логинов, паролей, заголовков статей, имен, фамилии и прочего.</li>
        <li><b> TEXT </b> - используется для хранения текста, разумеется используется очень часто</li>
        <li><b> INT </b> - самый популярный вариант использование этого типа - это <b> ID(уникальный идентификатор)</b>, который уникален для каждой записи в таблице.</li>
        <li><b> DATETIME </b> - используется для хранения даты и времени. Например, можно хранить дату и время отправки сообщения на форуме, дату и время регистрации пользователя и так далее</li>
    </ul><br>
    <span><b>
        TINYINT, DATE, SMALLINT, MEDIUMINT, BIGINT, FLOAT, DOUBLE, DECIMAL, TIMESTAMP, TIME, YEAR, CHAR, TINYTEXT, MEDIUMTEXT, LONGTEXT, ENUM, SET
    </b></span><br>
    <h2>Чтодает нам phpMyAdmin</h2>
    <span>
        <ul>
            <li>
                Просматривать, создавать, редактирвать и удалять:
                <ul>
                    <li>Пользователей</li>
                    <li>Базы данных</li>
                    <li>Таблицы в базе данных</li>
                    <li>Записи в таблице базы данных</li>
                </ul>
            </li>
            <li>Импортировать и экспортировать базы данных, таблицы и записи в них.</li>
            <li>Удобный поиск. </li>
            <li>Удобное администрирование. </li>
        </ul>
    </span>
    <h2>Создание, редактирование и удаление баз данных</h2>
    <span>
        Создать можно слева (где список БД есть кнопка "Создать бызу данных"), заполняем имя БД, в сравнении указывать кодировку(часто это кодировка "utf8_general_ci"), ну и кнопка создать. 
        <br>
        После можно создать внутри таблицу ну и работать с ней.
        <br>
        <b>Удалим ее</b>
        <br>
        Когда находимся в БД находим раздел операции и там есть действие удалить, так же можно изменять другие значениея(переименовать БД, изменить кодировку и т.д.)
        <br>
        <b>Создадим таблицу в БД</b>
        <br>
        Создавать таблиц можно множество и между ними могут быть связи. 
        <br>
        Добавляем поля(если зайдешь туда то там все понятно), если имя поля состоит больше одного слова, то записывать его нужно через нижнее подчеркивание. 
        <br>
        Перед созданием можно смотреть "предпросмотр sql" как будет выглядить таблица. 
        <br>
        После имени поля заполняется тип  поля и длину/значение.
        <br>
        Заполняй коментарии к таблице чтоб самому и тем кто будет работать с БД  было понятно. 
        <br>
        Так же есть раздел "NULL". Этот раздел при активной галке может иметь в таблице значение нулл. 
        <br>
        Столбик A I - это автоинкремент(автоматическое увеличение значения) 
        <br>
        Раздел sql
        <br>
        У нас есть запрос "     SELECT * FROM 'mytable'    " 
        <br>
        SELECT одначает выбрать, * - выбрать все столбцы,   FROM - из какой таблицы и название таблицы(то что в кавычках)
        <br>
        Если мы хотим вывести не все столбцы в таблице, то вместо * писать через запятую имя столбцов которые нужны. 
        <br>
        РАЗДЕЛ ВСТАВИТЬ. 
        <br>
        здесь можно добавлять новые записи.
        <br>
        <h2>Собственно чувак, если зайти на phpMyAdmin то там по идее все понятно по этому не буду заострять внимание на этом. Зайди и сам пойми что там проиходит </h2>
        <h2>Индексы и первичный ключ</h2>
        Это добро нужно для скорости запроса в БД. Индексы нужны для того чтобы выборка данных была быстрой. Если у нас есть большая таблица(допустим 10 000+ записей), когда  мы будем делать выборку с помощью SELECT и если нет индекса то буде долго ждать. Индекс бывает 2 типов первичный(для создания используется тип integer) и обычный индекс. 

        <br>
        Не увлекайся индексами иначе сортировка будет плохо. 
        <br>
        Так же с помощью индексов можно сделать связь между таблицами. 
        <br>
        <h2>Связи между таблицами (важная часть)</h2>
        Между таблицами может существовать 3 вида связей 
        <ul>
            <li>Один к одному</li>
            <li>Один ко многим</li>
            <li>Многие ко многим</li>
        </ul>
        <br>
        <h3>Один к одному</h3>
        Связь один к одному означает что к одному элементу из таблицы соответствует один элемент в другой таблицы. Допустим: В одной таблице элемент люди(есть айди первичный ключ с автоинкриментом(A I)) в другой таблице есть сертификат прививок(есть айди). связь идет по айди(если айди человека совпадает с айди сертификата прививок то эти таблицы в связи)
    </span>



    </div>
</body>

</html>